<?php

namespace SGalinski\SgNews\Hooks;

/***************************************************************
 *  Copyright notice
 *
 *  (c) sgalinski Internet Services (https://www.sgalinski.de)
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use SGalinski\SgNews\Utility\BackendNewsUtility;
use TYPO3\CMS\Backend\Utility\BackendUtility;

/**
 * Backend edid form hook
 */
class EditDocumentController {

	/**
	 * Sets the default value for the pages author field
	 * to the name of the logged-in user
	 *
	 * @param \TYPO3\CMS\Backend\Controller\EditDocumentController $controller Default configuration
	 * @return void
	 */
	public function preInitAfter($controller) {
		if (isset($controller->editconf['pages']) && $GLOBALS['BE_USER']->user['realName'] !== '') {
			$doktype = 0;
			foreach ($controller->editconf['pages'] as $pageUid => $command) {
				if ($command === 'edit') {
					$pageRow = BackendUtility::getRecord('pages', (int) $pageUid);
					if ($pageRow && isset($pageRow['doktype'])) {
						$doktype = (int) $pageRow['doktype'];
					}
				} elseif ($command === 'new' && isset($controller->overrideVals['pages']['doktype'])) {
					$doktype = (int) $controller->overrideVals['pages']['doktype'];
				}
				break;
			}
			if ($doktype === BackendNewsUtility::NEWS_DOKTYPE) {
				$GLOBALS['BE_USER']->userTS['TCAdefaults.']['pages.']['author'] = $GLOBALS['BE_USER']->user['realName'];
			}
		}
	}
}
